package main

import (
	"fmt"
	"math/rand"
)

func produce(ch chan<- int, n int) {
	for i := 0; i < n; i++ {
		ch <- i
	}

}

func consume(ch <-chan int) {
	for i := range ch {
		if i % 100 == 0 {
			fmt.Println(i)
		}
	}
}

func busywork(n int, done chan<- bool) {
	ch := make(chan int)
	go produce(ch, n)
	consume(ch)
	done <- true
}

const N = 1000

func main() {
	r := rand.New(rand.NewSource(1000000))
	done := make(chan bool)
	for i := 0; i < N; i++ {
		go busywork(r.Int(), done)
	}
	for i := 0; i < N; i++ {
		<-done
	}
}
